zoukankan      html  css  js  c++  java
  • poj3216 Prime Path(BFS)

    题目传送门

     Prime Path 

    The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
    — It is a matter of security to change such things every now and then, to keep the enemy in the dark.
    — But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
    — I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
    — No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
    — I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
    — Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

    Now, the minister of finance, who had been eavesdropping, intervened.
    — No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
    — Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
    — In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

    1033
    1733
    3733
    3739
    3779
    8779
    8179

    The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

    Input

    One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

    Output

    One line for each case, either with a number stating the minimal cost or containing the word Impossible.
     
    Sample Input
    3
    1033 8179
    1373 8017
    1033 1033

    Sample Output
    6
    7
    0
    题意:给你四位数字a,b;每一不只能改变一位数字,且新的数字只能是素数,
    要你输出最小步数

    题解:bfs,每次向下遍历40个方向

    代码:
    #include<iostream>
    #include<queue>
    #include<string.h>
    using namespace std;
    typedef long long ll;
    typedef unsigned long long ull;
    #define mod 1000000007
    #define INF 0x3f3f3f3f
    struct niu
    {
        int prime,step;
        niu(){}
        niu(int pr,int st)
        {
            prime=pr,step=st;
        }
    };
    int a,b;
    int ans=INF;
    bool check(int a)
    {
        for(int i=2;i*i<=a;i++)
            if(a%i==0)return false;
        return a!=1;
    }
    queue<niu>q;
    bool vis[10005];
    int bfs()
    {
        memset(vis,false,sizeof(vis));
        while(q.size())q.pop();
        q.push(niu(a,0));
        vis[a]=true;
        while(q.size())
        {
            niu tmp=q.front();q.pop();//cout<<tmp.prime<<tmp.step<<endl;
            if(tmp.prime==b)
            {
                ans=min(ans,tmp.step);
            }
            int cnt=tmp.prime%10;
            int cur=(tmp.prime/10)%10;
            for(int i=0;i<=9;i++)
            {
                int nx=(tmp.prime/10)*10+i;
                if(check(nx)&&!vis[nx])
                {
                    vis[nx]=true;
                    q.push(niu(nx,tmp.step+1));
                }
                int ny=(tmp.prime/100)*100+i*10+cnt;
                if(check(ny)&&!vis[ny])
                {
                    vis[ny]=true;
                    q.push(niu(ny,tmp.step+1));
                }
                int nz=(tmp.prime/1000)*1000+i*100+cur*10+cnt;
                if(check(nz)&&!vis[nz])
                {
                    vis[nz]=true;
                    q.push(niu(nz,tmp.step+1));
                }
                if(i==0)continue;
                int nn=(tmp.prime%1000)+i*1000;//cout<<nn<<endl;
                if(check(nn)&&!vis[nn])
                {
                    vis[nn]=true;
                    q.push(niu(nn,tmp.step+1));
                }
            }
        }
        return ans==INF?-1:ans;
    }
    int main()
    {
        int T;
        cin>>T;
        while(T--)
        {
            ans=INF;//注意这里的ans要初始化
            cin>>a>>b;
            if(bfs()==-1)
                cout<<"Impossible"<<endl;
            else cout<<bfs()<<endl;
        }
        return 0;

    
    

  • 相关阅读:
    数据结构(二)之链表
    数据结构(一)之数组,栈,队列
    记第一次学习Mybatis
    多线程基本实现方法(一)
    TCP三次握手及四次四次释放协议解析
    《绝不划水队》第一次作业:项目选题
    第一次博客作业
    vim cheatsheet
    js cheatsheet
    js re cheatsheet
  • 原文地址:https://www.cnblogs.com/zhgyki/p/9505027.html
Copyright © 2011-2022 走看看